(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@ionic/angular')) :
    typeof define === 'function' && define.amd ? define('ion-back-button-tabs', ['exports', '@angular/core', '@ionic/angular'], factory) :
    (factory((global['ion-back-button-tabs'] = {}),global.ng.core,global.angular));
}(this, (function (exports,core,angular) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BackButtonTabsDirective = /** @class */ (function () {
        function BackButtonTabsDirective(routerOutlet, navCtrl) {
            this.routerOutlet = routerOutlet;
            this.navCtrl = navCtrl;
        }
        /**
         * @param {?} ev
         * @return {?}
         */
        BackButtonTabsDirective.prototype.onClick = /**
         * @param {?} ev
         * @return {?}
         */
            function (ev) {
                /** @type {?} */
                var lastTabUrl;
                /** @type {?} */
                var nonCrclrRtrOtlt = JSON.parse(JSON.stringify(this.routerOutlet, this.getCircularReplacer()));
                if (this.backToTabs(nonCrclrRtrOtlt)) {
                    /** @type {?} */
                    var stackCtrl = this.getTabsStackCtrl(nonCrclrRtrOtlt);
                    lastTabUrl = this.getLastViewUrl(stackCtrl);
                }
                if (this.routerOutlet && this.routerOutlet.canGoBack() && lastTabUrl) {
                    this.navCtrl.navigateBack(lastTabUrl);
                    ev.preventDefault();
                }
                else if (this.routerOutlet && this.routerOutlet.canGoBack()) {
                    this.routerOutlet.pop();
                    ev.preventDefault();
                }
                else if (this.defaultHref != null) {
                    this.navCtrl.navigateBack(this.defaultHref);
                    ev.preventDefault();
                }
            };
        /**
         * @private
         * @param {?} nonCrclrRtrOtlt
         * @return {?}
         */
        BackButtonTabsDirective.prototype.backToTabs = /**
         * @private
         * @param {?} nonCrclrRtrOtlt
         * @return {?}
         */
            function (nonCrclrRtrOtlt) {
                /** @type {?} */
                var views = nonCrclrRtrOtlt.stackCtrl.views;
                /** @type {?} */
                var topUrls = [];
                for (var i = 0; i < views.length; i++) {
                    if (views[i]) {
                        topUrls.push(views[i].url);
                    }
                }
                return (topUrls[topUrls.length - 1] === "/" + this.tabsPrefix);
            };
        /**
         * @private
         * @param {?} stackCtrl
         * @return {?}
         */
        BackButtonTabsDirective.prototype.getLastViewUrl = /**
         * @private
         * @param {?} stackCtrl
         * @return {?}
         */
            function (stackCtrl) {
                if (stackCtrl && stackCtrl.views && stackCtrl.views.length > 0) {
                    return stackCtrl.views[stackCtrl.views.length - 1].url;
                }
            };
        /**
         * @private
         * @param {?} obj
         * @return {?}
         */
        BackButtonTabsDirective.prototype.getTabsStackCtrl = /**
         * @private
         * @param {?} obj
         * @return {?}
         */
            function (obj) {
                /** @type {?} */
                var result = null;
                if (obj instanceof Array) {
                    for (var i = 0; i < obj.length; i++) {
                        result = this.getTabsStackCtrl(obj[i]);
                        if (result) {
                            break;
                        }
                    }
                }
                else {
                    // tslint:disable-next-line:forin
                    for (var prop in obj) {
                        if (prop === 'stackCtrl') {
                            if (obj.stackCtrl.hasOwnProperty('tabsPrefix') && obj.stackCtrl.tabsPrefix[0] === this.tabsPrefix) {
                                return obj.stackCtrl;
                            }
                        }
                        if (obj[prop] instanceof Object || obj[prop] instanceof Array) {
                            result = this.getTabsStackCtrl(obj[prop]);
                            if (result) {
                                break;
                            }
                        }
                    }
                }
                return result;
            };
        /**
         * @private
         * @return {?}
         */
        BackButtonTabsDirective.prototype.getCircularReplacer = /**
         * @private
         * @return {?}
         */
            function () {
                /** @type {?} */
                var seen = new WeakSet;
                return ( /**
                 * @param {?} key
                 * @param {?} value
                 * @return {?}
                 */function (key, value) {
                    if (typeof value === 'object' && value !== null) {
                        if (seen.has(value)) {
                            return;
                        }
                        seen.add(value);
                    }
                    return value;
                });
            };
        BackButtonTabsDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[ionBackButtonTabs]'
                    },] }
        ];
        /** @nocollapse */
        BackButtonTabsDirective.ctorParameters = function () {
            return [
                { type: angular.IonRouterOutlet, decorators: [{ type: core.Optional }] },
                { type: angular.NavController }
            ];
        };
        BackButtonTabsDirective.propDecorators = {
            defaultHref: [{ type: core.Input }],
            tabsPrefix: [{ type: core.Input }],
            onClick: [{ type: core.HostListener, args: ['click', ['$event'],] }]
        };
        return BackButtonTabsDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BackButtonTabsComponent = /** @class */ (function () {
        function BackButtonTabsComponent() {
        }
        BackButtonTabsComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ion-back-button-tabs',
                        template: "<ion-back-button [defaultHref]=\"defaultHref\" [tabsPrefix]=\"tabsPrefix\" ionBackButtonTabs></ion-back-button>"
                    }] }
        ];
        BackButtonTabsComponent.propDecorators = {
            defaultHref: [{ type: core.Input }],
            tabsPrefix: [{ type: core.Input }]
        };
        return BackButtonTabsComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BackButtonTabsModule = /** @class */ (function () {
        function BackButtonTabsModule() {
        }
        BackButtonTabsModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            angular.IonicModule
                        ],
                        declarations: [
                            BackButtonTabsDirective,
                            BackButtonTabsComponent
                        ],
                        exports: [
                            BackButtonTabsComponent
                        ]
                    },] }
        ];
        return BackButtonTabsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.BackButtonTabsDirective = BackButtonTabsDirective;
    exports.BackButtonTabsComponent = BackButtonTabsComponent;
    exports.BackButtonTabsModule = BackButtonTabsModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ion-back-button-tabs.umd.js.map